﻿using EJGrid.Models;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.JavaScript.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Linq.Expressions;
using System.Web;
using System.Web.Mvc;
using System.Web.UI.WebControls;
using System.Xml;
using Syncfusion.Linq;
using System.Web.Script.Serialization;

namespace EJGrid.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.parentData = OrderRepository.GetAllRecords1().ToList();
            return View();
        }
        public ActionResult DataSource(DataManager dm)
        {
            var DataSource = OrderRepository.GetAllRecords1().ToList();
            DataResult result = new DataResult();
            result.result = DataSource.Skip(dm.Skip).Take(dm.Take).ToList();
            result.count = DataSource.Count();
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Validate(EditableOrder order)
        {
            if (!ModelState.IsValid)
            {
                List<string> errorlist = new List<string>();
                foreach (ModelState modelState in ModelState.Values)
                {
                    foreach (ModelError error in modelState.Errors)
                    {
                        errorlist.Add(error.ErrorMessage);
                    }
                }
                return Content(new JavaScriptSerializer().Serialize(errorlist));
            }
            return Content("true");
        }
        public JsonResult Update(EditableOrder value)
        {
            OrderRepository.Update(value);
            var data = OrderRepository.GetAllRecords1();
            return Json(value, JsonRequestBehavior.AllowGet);
        }
        public JsonResult Add(EditableOrder value)
        {
            OrderRepository.Add(value);
            var data = OrderRepository.GetAllRecords1();
            return Json(value, JsonRequestBehavior.AllowGet);
        }
        public JsonResult Remove(int key)
        {
            OrderRepository.Delete(key);
            var data = OrderRepository.GetAllRecords1();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}